

// Pin number
const uint8_t pinSW2 = 0;
const uint8_t pinSW3 = 4;
const uint8_t pinSW4 = 16;
const uint8_t pinSW5 = 5;
const uint8_t pinSDCS = 17;
const uint8_t pinSDA = 21;
const uint8_t pinSCL = 22;
const uint8_t pinPWM = 32;
const uint8_t pinLE = 13;
const uint8_t pinLoad = 33;
const uint8_t pinLED1 = 25;
const uint8_t pinLED2 = 26;
const uint8_t pinLED3 = 27;
const uint8_t pinLED4 = 14;
const uint8_t pinADC = 36;



void setup() {
  Serial.begin(115200);
  delay(10);
  Serial.print("\n\n-----------------------\n");
  Serial.print("Program Start\n");

  
  // Pin
  digitalWrite(pinLE, LOW);
  digitalWrite(pinLoad, HIGH);  // HIGH = OFF
  digitalWrite(pinLED1, HIGH);  // HIGH = OFF
  digitalWrite(pinLED2, HIGH);  // HIGH = OFF
  digitalWrite(pinLED3, HIGH);  // HIGH = OFF
  digitalWrite(pinLED4, HIGH);  // HIGH = OFF
  pinMode(pinLE, OUTPUT);
  pinMode(pinLoad, OUTPUT);
  pinMode(pinLED1, OUTPUT);
  pinMode(pinLED2, OUTPUT);
  pinMode(pinLED3, OUTPUT);
  pinMode(pinLED4, OUTPUT);
  pinMode(pinSW2, PULLUP);
  pinMode(pinSW3, PULLUP);
  pinMode(pinSW4, PULLUP);
  pinMode(pinSW5, PULLUP);
  ledcSetup(0, 3000, 8);
  ledcAttachPin(pinPWM, 0);
}


void loop() {
  float vcrg = vcharge();
  Serial.print("VCRG : ");
  Serial.print(vcharge());
  Serial.println("V");
  delay(5000);
}

// ADCを使って充電器入力の電圧を取得
float vcharge(){
  float vcrg = 3.3 * 115 / 15 * analogRead(pinADC) / 4095;  // 10kと1.5kで分圧している分を逆算
  if(vcrg < 0.1){
    return 0;         // 非常に低い場合は0を返す
  }
  return vcrg + 1.15; // 実際の電圧より低めになるのを補正
}






